{ RRRRRR                  ReportBuilder Class Library                  BBBBB
  RR   RR                                                              BB   BB
  RRRRRR                 Digital Metaphors Corporation                 BB BB
  RR  RR                                                               BB   BB
  RR   RR                   Copyright (c) 1996-2006                    BBBBB   }

unit myEURpt;

{$I ppIfDef.pas}

interface

{ By removing the 'x' which begins each of these compiler directives,
  you can enable different functionality within the end-user reporting
  solution.

  DADE - the data tab where queries can be created by the end-user

  BDE  - BDE support for the Query Tools

  ADO  - ADO support for the Query Tools

  IBExpress - Interbase Express support for the Query Tools

  RAP -  the calc tab, where calculations can be coded at run-time
         (RAP is included with ReportBuilder Enterprise)

  CrossTab - adds the CrossTab component to the component palette in the
             report designer.

  CheckBox - adds a checkbox component to the component palette in the
         report designer.

  TeeChart - adds a teechart component to the report designer component
         palette. You must have TeeChart installed. More information
         is available in ..\RBuilder\TeeChart\ReadMe.doc

  UseDesignPath - determines whether the path used by the Database
         object on this form is replaced in the OnCreate event handler of
         this form with the current path.}

{$DEFINE DADE}            {remove the 'x' to enable DADE}
{$DEFINE BDE}             {remove the 'x' to enable Borland Database Engine (BDE) }
{x$DEFINE ADO}            {remove the 'x' to enable ADO}
{x$DEFINE IBExpress}      {remove the 'x' to enable Interbase Express}
{$DEFINE CrossTab}        {remove the 'x' to enable CrossTab}
{x$DEFINE RAP}            {remove the 'x' to enable RAP}
{$DEFINE CheckBox}       {remove the 'x' to enable CheckBox}
{x$DEFINE TeeChart}       {remove the 'x' to enable standard TeeChart}
{x$DEFINE UseDesignPath}  {remove the 'x' to use the design-time settings of Database object on this form}

uses

{$IFDEF DADE}
  daIDE, 
{$ENDIF}

{$IFDEF BDE}
  daDBBDE,
{$ENDIF}

{$IFDEF ADO}
  daADO,
{$ENDIF}

{$IFDEF IBExpress}
  daIBExpress,
{$ENDIF}

{$IFDEF CrossTab}
  ppCTDsgn,
{$ENDIF}

{$IFDEF RAP}
  raIDE,
{$ENDIF}

{$IFDEF CheckBox}
  myChkBoxDesign,
{$ENDIF}

{$IFDEF TeeChart}
  ppChrtUI,
{$ENDIF}

{$IFDEF Delphi7}
  {$IFNDEF Delphi11}
    XPMan,
  {$ENDIF}
{$ENDIF}

  Windows, Classes, Controls, SysUtils, Forms, StdCtrls, ExtCtrls, Dialogs, Graphics,
  DB, DBTables,  ppComm, ppCache, ppClass, ppProd, ppReport, ppRptExp, ppBands,
  ppDBBDE, ppEndUsr, ppDBPipe, ppDB, ppPrnabl, ppStrtch, ppDsgnDB,
  ppRelatv, ppModule, ppViewr, ppForms, ppFormWrapper,
  Variants;

type

  TmyEndUserSolution = class(TForm)
    Shape11: TShape;
    Label6: TLabel;
    Shape12: TShape;
    euDatabase: TDatabase;
    Shape9: TShape;
    Label5: TLabel;
    Shape10: TShape;
    tblTable: TTable;
    dsTable: TDataSource;
    plTable: TppBDEPipeline;
    tblField: TTable;
    dsField: TDataSource;
    plField: TppBDEPipeline;
    Shape6: TShape;
    Label7: TLabel;
    Shape5: TShape;
    ppDesigner1: TppDesigner;
    Shape4: TShape;
    Label8: TLabel;
    Shape3: TShape;
    dsItem: TDataSource;
    plItem: TppBDEPipeline;
    Shape13: TShape;
    Label3: TLabel;
    Shape14: TShape;
    Shape18: TShape;
    Label9: TLabel;
    Shape19: TShape;
    ppReport1: TppReport;
    Label1: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Shape15: TShape;
    Label2: TLabel;
    Shape16: TShape;
    tblFolder: TTable;
    dsFolder: TDataSource;
    plFolder: TppBDEPipeline;
    btnLaunch: TButton;
    ppReportExplorer1: TppReportExplorer;
    Shape22: TShape;
    Label10: TLabel;
    Shape23: TShape;
    Shape24: TShape;
    Shape25: TShape;
    Shape26: TShape;
    Memo1: TMemo;
    pnlStatusBar: TPanel;
    Shape7: TShape;
    Shape8: TShape;
    Shape17: TShape;
    Shape20: TShape;
    ppHeaderBand1: TppHeaderBand;
    ppDetailBand1: TppDetailBand;
    ppFooterBand1: TppFooterBand;
    ppDataDictionary1: TppDataDictionary;
    qryItem: TQuery;
    qryItemUpdate: TQuery;
    dsItemUpdate: TDataSource;
    plItemUpdate: TppBDEPipeline;
    procedure FormCreate(Sender: TObject);
  private
    FTimer: TTimer;

    procedure TimerEvent(Sender: TObject);

    procedure ehReport_LoadEnd(Sender: TObject);
    procedure ehReport_New(Sender: TObject);
  public
    function GetFolderId(aFolderName: String): Integer;
  end;

var
  myEndUserSolution: TmyEndUserSolution;

implementation

{$R *.DFM}

uses
  ppTypes;

{------------------------------------------------------------------------------}
{ TmyEndUserSolution.FormCreate }

procedure TmyEndUserSolution.FormCreate(Sender: TObject);
{$IFNDEF UseDesignPath}
var
  lsPathName: String;
{$ENDIF}
begin

{$IFNDEF UseDesignPath}
  euDatabase.Connected := False;

  lsPathName := ExtractFilePath(ParamStr(0));
  lsPathName := AnsiUpperCase(lsPathName);
  lsPathName := Copy(lsPathName,1, Pos('\3. ENDUSER',lsPathName));

  euDatabase.Params.Values['PATH'] := lsPathName + 'DATA\';
{$ENDIF}

  euDatabase.Connected := True;
  
  ClientHeight := btnLaunch.Top + btnLaunch.Height + pnlStatusBar.Height + 8;

  ppReport1.Template.OnLoadEnd := ehReport_LoadEnd;
  ppReport1.Template.OnNew := ehReport_New;

  FTimer := TTimer.Create(Self);
  FTimer.Interval := 100;
  FTimer.OnTimer  := TimerEvent;

end; {procedure, FormCreate}



{------------------------------------------------------------------------------}
{ TmyEndUserSolution.TimerEvent }

procedure TmyEndUserSolution.TimerEvent(Sender: TObject);
var
  lsMessage: String;
begin

 FTimer.Free;

 if not(ppReportExplorer1.Execute) then
    begin
      lsMessage := 'Error: ' + ppReportExplorer1.ErrorMessage;
      
      MessageDlg(lsMessage, mtError, [mbOK], 0);
    end;

 Application.Terminate;

end;  {procedure, TimerEvent}

{------------------------------------------------------------------------------}
{ TmyEndUserSolution.ehReport_LoadEnd }

procedure TmyEndUserSolution.ehReport_LoadEnd(Sender: TObject);
begin

  ppReportExplorer1.CurrentFolderId := GetFolderId('Customers');

end;

{------------------------------------------------------------------------------}
{ TmyEndUserSolution.ehReport_New }

procedure TmyEndUserSolution.ehReport_New(Sender: TObject);
begin

  ppReportExplorer1.CurrentFolderId := GetFolderId('Customers');

end;

{------------------------------------------------------------------------------}
{ TmyEndUserSolution.GetFolderId }

function TmyEndUserSolution.GetFolderId(aFolderName: String): Integer;
var
  lsFieldNames: String;
  lbFolderExists: Boolean;
begin

  // key is folder name, parent id
  lsFieldNames := ppReportExplorer1.FolderFieldNames.Name + ';' +
                  ppReportExplorer1.FolderFieldNames.ParentId;

  // locate the folder record
  lbFolderExists := ppReportExplorer1.FolderPipeline.Locate(lsFieldNames, VarArrayOf([aFolderName, 0]), [pploCaseInsensitive]);

  // return the folder id
  if lbFolderExists then
    Result := ppReportExplorer1.FolderPipeline[ppReportExplorer1.FolderFieldNames.FolderId]
  else
    Result := 0;

end;



end.
